<?php
/**
* @Copyright Copyright (C) 2010 Brent Laminack
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

// the work's all done here, getting the info and making the call to the MailChimp API
function send_to_mc(){

  $email = isset($_POST['email'])?$_POST['email']:'';
  $mid =  isset($_POST['mid'])?$_POST['mid']:'';
  $first =  isset($_POST['first'])?$_POST['first']:'';
  $last =  isset($_POST['last'])?$_POST['last']:'';
  $ig =  isset($_POST['ig'])?$_POST['ig']:'';
  $ig_struct = make_ig($ig);

  global $mainframe;

  $db =& JFactory::getDBO();
  
	// Validation
	if(!$email){ 
		return "No email address provided"; 
	} 



  // 1.5 method for manually retrieving api key
  
  $query = "select params from #__modules where id = '$mid'";
  $db->setQuery( $query );
  if (null === ($raw_params = $db->loadResult())) {
                        JError::raiseWarning( 'SOME_ERROR_CODE', JText::_( 'Error Loading Params' ) . $db->getErrorMsg());
                        return false;
        }
  jimport( 'joomla.html.parameter' );
  
  $params = new JParameter( $raw_params );
  $apikey = $params->get('mc_api_key');
  

	if(!$apikey){
    $retval = JText::_('MOD_MAILCHIMP2_ERROR_NO_API_KEY');
		return($retval);
	}

	// pull in the MailChimp API
	require_once('MCAPI.class.php');
	require_once('mod_mailchimp2_helper.php');
	$api = new MODMC2_MCAPI($apikey);
	
	$list = get_list($api, $params);

	if(!$list['id']){
    $retval = JText::_('MOD_MAILCHIMP2_ERROR_NO_LIST');
		return $retval;
	}

	$mergevars = $api->listMergeVars($list['id']);

	// finally! the Subscribe
	$merge_vars_togo = array();
	$err_tags = array();
	$err_names = array();
	foreach($mergevars as $mergevar){
		$tag = $mergevar['tag'];
		$err_tags[] = "/$tag/";
		$err_names[] = $mergevar['name'];
		if($tag == 'EMAIL') {
			continue;
		} else {
			if(  isset($_POST[$tag])  ){
				$merge_vars_togo[$tag]=$_POST[$tag];
			}
		}
	}
	if($ig_struct){
		$merge_vars_togo['GROUPINGS']=$ig_struct;
	}
	if(!count($merge_vars_togo)) {
		$merge_vars_togo = '';
	}
	if($api->listSubscribe($list['id'], $email, $merge_vars_togo) === true) {
		// It worked!	
		$retval = JText::_('MOD_MAILCHIMP2_MESSAGE_SUCCESS');
    return $retval;
	} else {
		// An error ocurred, return error message
    $retval = JText::_('MOD_MAILCHIMP2_ERROR_SUBSCRIBE');	
		return $retval . preg_replace($err_tags, $err_names, $api->errorMessage);
	}
	
}

function make_ig($all_igs){

	/* need to end up with:
	Set Interest Groups by Grouping. 
	Each element in this array should be an array containing the "groups" parameter which contains 
	a comma delimited list of Interest Groups to add. 
	Commas in Interest Group names should be escaped with a backslash. ie, "," => "\," 
	and either an "id" or "name" parameter to specify the Grouping - get from listInterestGroupings()

	merge_vars = array ('GROUPINGS' => array('id'=> group_id1, 'groups'=>'ecommerce,marketing,joomla 1.8',
						'id'=> group_id2, 'groups'=>'male');
				.......
	*/

	$igs = "";
	
	$tmp=preg_replace('/,$/', '', $all_igs);

	$parts = explode(',', $tmp);

	$parts[] = 'mcig_0';	// end of file 

	$ret = array();

	$group = array();
	$group_id = "";
	
	for($i = 0; $i<count($parts); $i++){
		$this_part = $parts[$i];
		if(preg_match('/^mcig_/', $this_part)){
			// finish previous array
			if($igs and $group_id){
				$group['id'] = $group_id;
				$igs = preg_replace('/,$/', '', $igs);
				$group['groups'] = $igs;
				$ret[] = $group;
				$group = array();
				$id = '';
				$igs = '';
			}
			$group_id = preg_replace('/^mcig_/', '', $this_part);
		} else {
			$igs .= $this_part . ',';
		}
	}
	return($ret);
}	// end of make_ig 

// If being called via ajax, autorun the function with email address and module id
if($_POST['ajax']){ echo send_to_mc(); }


//EOF